#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
sys.path.append('/usr/lib/openoffice/basis-link/program')
sys.path.append('/usr/lib/libreoffice/basis-link/program')
import os
import uno
import time
import string

#a UNO struct later needed to create a document
from com.sun.star.text.ControlCharacter import PARAGRAPH_BREAK
from com.sun.star.text.TextContentAnchorType import AS_CHARACTER
from com.sun.star.awt import Size
from com.sun.star.lang import XMain
from com.sun.star.table import BorderLine
import psycopg2


def insertTextIntoCell(table, cellName, text, color, rotation, alignment):
	tableText = table.getCellByName(cellName)
	cursor = tableText.createTextCursor()
	cursor.setPropertyValue("CharColor", color)
	cursor.setPropertyValue("CharRotation",rotation)
	cursor.setPropertyValue("ParaAdjust",alignment);
	cursor.setPropertyValue("CharHeight", 10)
	tableText.setString(text)

def mergeCells(Table,cellName,dx,dy):
	cursor = Table.createCursorByCellName(cellName)
	if dx>0:
		cursor.goRight(dx,True)
	if dy>0:
		cursor.goDown(dy,True)
	cursor.mergeRange()

def insertFormattedText(text, cursor, color, height, weight, font, shadow, alignment, rotation, string):
	cursor.setPropertyValue("CharColor", color)
	cursor.setPropertyValue("CharShadowed", shadow)
	cursor.setPropertyValue("CharHeight", height)
	cursor.setPropertyValue("CharFontName", font)
	cursor.setPropertyValue("CharWeight", weight)
	cursor.setPropertyValue("CharRotation",rotation)
	cursor.setPropertyValue("ParaAdjust",alignment);
	text.insertString(cursor, string,0)


def ABC(k):
	if k>=65  and k<91:
		b=chr(k)
	if k>=91 and k<=116:
		b=chr(k+6)
	return b


def convertToURL( cPathname ):
    if len( cPathname ) > 1:
        if cPathname[1:2] == ":":
            cPathname = "/" + cPathname[0] + "|" + cPathname[2:]
    cPathname = string.replace( cPathname, "\\", "/" )
    cPathname = "file://" + cPathname
    return cPathname 

def setTableColumnSeparators(table, seps):
	oTblColSeps = table.getPropertyValue('TableColumnSeparators')
	if len(oTblColSeps)>len(seps):
		N = len(seps)
	else:
		N = len(oTblColSeps)
	for i in range(N):
		oTblColSeps[i].Position = seps[i]
	table.TableColumnSeparators = oTblColSeps

def print_to_ooo():
	localContext = uno.getComponentContext()
	resolver = localContext.ServiceManager.createInstanceWithContext("com.sun.star.bridge.UnoUrlResolver", localContext)
	try:
		ctx = resolver.resolve("uno:socket,host=localhost,port=2002;urp;StarOffice.ComponentContext")
	except:
		time.sleep(3)
		try:
			ctx = resolver.resolve("uno:socket,host=localhost,port=2002;urp;StarOffice.ComponentContext")
		except:
			time.sleep(3)
			try:
				ctx = resolver.resolve("uno:socket,host=localhost,port=2002;urp;StarOffice.ComponentContext")
			except:
				time.sleep(3)
				try:
					ctx = resolver.resolve("uno:socket,host=localhost,port=2002;urp;StarOffice.ComponentContext")
				except:
					time.sleep(3)
					try:
						ctx = resolver.resolve("uno:socket,host=localhost,port=2002;urp;StarOffice.ComponentContext")
					except:
						time.sleep(3)
						try:
							ctx = resolver.resolve("uno:socket,host=localhost,port=2002;urp;StarOffice.ComponentContext")
						except:
							time.sleep(3)
							try:
								ctx = resolver.resolve("uno:socket,host=localhost,port=2002;urp;StarOffice.ComponentContext")
							except:
								time.sleep(3)
								try:
									ctx = resolver.resolve("uno:socket,host=localhost,port=2002;urp;StarOffice.ComponentContext")
								except:
									time.sleep(3)
									try:
										ctx = resolver.resolve("uno:socket,host=localhost,port=2002;urp;StarOffice.ComponentContext")
									except:
										time.sleep(3)
										try:
											ctx = resolver.resolve("uno:socket,host=localhost,port=2002;urp;StarOffice.ComponentContext")
										except:
											time.sleep(3)
											print "Failed connection to the OOo"
											sys.exit()
	smgr = ctx.ServiceManager
	desktop = smgr.createInstanceWithContext("com.sun.star.frame.Desktop",ctx)
	model = desktop.loadComponentFromURL('private:factory/swriter', '_blank', 0, ())
	text = model.Text
	cursor = text.createTextCursor()
	cursor.gotoEnd("false")
	f = open(sys.argv[1], "rt")
	Rows = 0
	Columns = 0
	Spans = []
	Widths = []
	Header = ""
	image_fl = 0
	image = ""
	table_model = []
	wid = 10000
	hig = 5000
	while 1:
		string = f.readline()
		if string == "":
			break
		else:
			if string.split('=')[0] == "Header":
				Header = string.split('=')[1]
			else:
				if string.split('=')[0] == "Rows":
					Rows = long(string.split('=')[1])
				else:
					if string.split('=')[0] == "Columns":
						Columns = long(string.split('=')[1])
					else:
						if string.split('=')[0] == "Spans":
							tup = string.split('=')[1].split('|')
							for i in tup:
								Spans.append([i.split(',')[0],long(i.split(',')[1]),long(i.split(',')[2])])
						else:
							if string.split('=')[0] == "Wigths":
								Widths.append(long(string.split('=')[1]))
							else:
								if string.split('=')[0] == "Image":
									image = string.split('=')[1].split('\n')[0]
									image_fl = 1
								else:
									if string.split('=')[0] == "Image_sizes":
										wid = string.split('=')[1].split(',')[0]
										hig= string.split('=')[1].split(',')[1]
									else:
										table_model.append(string.split('|'))
	insertFormattedText(text, cursor, 0, 14, 105, "Arial", uno.Bool(1),3,0, Header.decode("utf-8"))
	print Widths

	cursor.gotoEnd("false")
	if Rows > 0 and Columns>1:
		table = model.createInstance("com.sun.star.text.TextTable")
		table.initialize(Rows,Columns)
		text.insertTextContent(cursor, table, 0)

	for i in range(Rows):
		for j in range(Columns):
			insertTextIntoCell(table, "%c"%(ABC(65+j)) + "%d"%(i+1), table_model[i][j].decode("utf-8"), 0,0,0)
	if Rows > 0 and Columns>1:
		setTableColumnSeparators(table, Widths)

		for i in range(len(Spans)):
			mergeCells(table, Spans[i][0], Spans[i][1], Spans[i][2])

		rows = table.Rows
		ref = []
		for j in range(Columns):
			ref.append("")
		ref.append("\n")
		if ref == table_model[0]:
			rows.removeByIndex(0,1)
		borderLine  = BorderLine()
		borderLine.OuterLineWidth = 10

	if Rows > 0 and Columns>1:
		tableBorder = table.getPropertyValue("TableBorder")

		tableBorder.VerticalLine = borderLine
		tableBorder.HorizontalLine = borderLine
		tableBorder.LeftLine = borderLine
		tableBorder.RightLine = borderLine
		tableBorder.TopLine = borderLine
		tableBorder.BottomLine = borderLine

		tableBorder.IsBottomLineValid     = True
		tableBorder.IsTopLineValid             = True
		tableBorder.IsLeftLineValid             = True
		tableBorder.IsRightLineValid         = True
		tableBorder.IsHorizontalLineValid = True
		tableBorder.IsVerticalLineValid     = True 


		table.setPropertyValue("TableBorder", tableBorder)

	if image_fl == 1:
		oShape = model.createInstance("com.sun.star.drawing.GraphicObjectShape")
		
		OBitMap = model.createInstance( "com.sun.star.drawing.BitmapTable" ) 
		OBitMap.insertByName("backgroud",convertToURL(image))
		Url = OBitMap.getByName("backgroud")
		oShape.GraphicURL = Url
		
		#oShape.GraphicURL = convertToURL(image)
		size = uno.createUnoStruct('com.sun.star.awt.Size')
		size.Width = wid
		size.Height = hig
		oShape.Size = size 
		text.insertTextContent(cursor,oShape,uno.Bool(0))


print_to_ooo()