import QtQuick 1.0

Item {
    id: main

    property bool stateFlag: false
    property int valueLeft : 0
    property int valueRight : 0
    property string titleStr: "новый виджет"

    width: 900
    height: 320

    Item {
        id: rectangle1
        x: 0
        y: 0
        width: 900
        height: 320
        anchors.horizontalCenter: parent.horizontalCenter
        opacity: 1

        Text {
            id: title
            width: 160
            height: 20
            text: titleStr
            anchors.top: parent.top
            anchors.topMargin: 0
            anchors.horizontalCenter: parent.horizontalCenter
            smooth: true
            horizontalAlignment: Text.AlignHCenter
            font.pixelSize: 22
        }

        Text {
            id: titleRight
            y: 162
            width: 80
            height: 20
            text: "П."
            opacity: 0
            anchors.left: dialRight.right
            anchors.leftMargin: 0
            anchors.verticalCenter: dialRight.verticalCenter
            smooth: true
            font.pixelSize: 22
        }

        Text {
            id: titleLeft
            y: 162
            width: 80
            height: 20
            text: "Л."
            opacity: 0
            anchors.left: dialLeft.right
            anchors.leftMargin: 0
            anchors.verticalCenter: dialLeft.verticalCenter
            smooth: true
            horizontalAlignment: Text.AlignLeft
            font.pixelSize: 22
        }

        Dial {
            id: dialRight
            x: 600
            y: 20
            anchors.right: parent.right
            anchors.rightMargin: 0
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 0
            value: valueRight
        }

        Dial {
            id: dialLeft
            anchors.left: parent.left
            anchors.leftMargin: 0
            anchors.top: parent.top
            anchors.topMargin: 20
            value: valueLeft
        }
    }
    states: [
        State {
            name: "State1"

            PropertyChanges {
                target: dialLeft
                x: 150
                y: 0
                rotation: 0
            }

            PropertyChanges {
                target: dialRight
                x: 450
                y: 0
                rotation: 0
            }

            PropertyChanges {
                target: main
                width: 400
                height: 620
            }

            PropertyChanges {
                target: titleLeft
                opacity: 1
            }

            PropertyChanges {
                target: titleRight
                opacity: 1
            }

            PropertyChanges {
                target: rectangle1
                width: 300
                height: 620
                opacity: 1
            }
            when: stateFlag
        }
    ]
    transitions: [
      Transition {
         NumberAnimation { properties: "width,height,opacity"; duration: 600 }
      }
    ]
}
