import QtQuick 1.0

Item {
    id:main

    property bool stateFlag: false
    property real valueLeft : 0
    property real valueRight : 0
    property string titleStr: "новый виджет"
    property string leftStr: "Левый двигатель"
    property string rightStr: "Правый двигатель"

    width: 900
    height: 120

    Fuel {
        id: fuelLeft
        y: 20
        anchors.top: parent.top
        anchors.topMargin: 20
        anchors.left: parent.left
        anchors.leftMargin: 100
        value: valueLeft

        Text {
            id: titleLeft
            x: 72
            y: 36
            width: 80
            height: 20
            text: "Л."
            opacity: 0
            anchors.verticalCenter: parent.verticalCenter
            smooth: true
            horizontalAlignment: Text.AlignHCenter
            font.pixelSize: 22
        }
    }

    Fuel {
        id: fuelRight
        x: 700
        anchors.right: parent.right
        anchors.bottom: parent.bottom  
        anchors.bottomMargin: 0
        anchors.rightMargin: 100  
        value: valueRight

        Text {
            id: titleRight
            x: 73
            y: 36
            width: 80
            height: 20
            text: "П."
            opacity: 0
            anchors.verticalCenterOffset: 0
            anchors.verticalCenter: parent.verticalCenter
            horizontalAlignment: Text.AlignHCenter
            font.pixelSize: 22
        }
    }

    Text {
        id: title
        x: 410
        y: 46
        width: 80
        height: 20
        text: titleStr
        smooth: true
        anchors.horizontalCenterOffset: 0
        anchors.top: parent.top
        anchors.topMargin: 0
        anchors.horizontalCenter: parent.horizontalCenter
        horizontalAlignment: Text.AlignHCenter
        font.pixelSize: 22
    }

    Text {
        id: left
        x: 110
        y: 0
        width: 80
        height: 20
        text: leftStr
        smooth: true
        horizontalAlignment: Text.AlignHCenter
        font.pixelSize: 22
    }

    Text {
        id: right
        x: 710
        y: 0
        width: 80
        height: 20
        text: rightStr
        horizontalAlignment: Text.AlignHCenter
        smooth: true
        font.pixelSize: 22
    }
    states: [
        State {
            name: "State1"

            PropertyChanges {
                target: main
                width: 300
                height: 220
            }

            PropertyChanges {
                target: left
                opacity: 0
            }

            PropertyChanges {
                target: right
                opacity: 0
            }

            PropertyChanges {
                target: titleLeft
                opacity: 1
            }

            PropertyChanges {
                target: titleRight
                opacity: 1
            }
            when: stateFlag
        }
    ]
    transitions: [
      Transition {
         NumberAnimation { properties: "width,height,opacity"; duration: 600 }
      }
    ]
}
