import QtQuick 1.0

Rectangle {
    id: main

    property real sca: Math.max(main.width/900,0.1)

    //===================================================
//    property int valueEngineLeft : 0
//    property int valueEngineRight : 0
//    property int valueShaftLeft : 0
//    property int valueShaftRight : 0
//    property real valueFuelLeft : 0
//    property real valueFuelRight : 0
//    property real valueSpeed : 0
//    property real valueDiselLeft : 0
//    property real valueDiselRight : 0
//    property real mainwidth : 900
//    property real mainheight : 600
    //===================================================

    width: mainwidth
    height: mainheight

    gradient: Gradient {
             GradientStop { position: 0.0; color: "#E2E2E2" }
             GradientStop { position: 1.0; color: "#787777" }
         }
    Flickable {
        id: flickable1
        height: main.height
        //anchors.horizontalCenterOffset: smeshenie//(900-main.width)/2
        //anchors.horizontalCenter: parent.horizontalCenter
        anchors.bottom: parent.bottom
        anchors.top: parent.top
        width: main.width
        contentHeight: column.height*sca

        Column{
            id: column
            x: 0
            transform: Scale {xScale: sca; yScale: sca}
            
            Status {
                id:status
                value: valStatus
            }

            Speed {
                id: speed
                anchors.horizontalCenter: parent.horizontalCenter
                value: valueSpeed
                titleStr: "Скорость"
            }

            FuelWidget {
                id: fuelwidget
                anchors.horizontalCenter: parent.horizontalCenter
                stateFlag: main.width < 450
                valueLeft: valueFuelLeft
                valueRight: valueFuelRight
                titleStr: " Расход топлива"
            }

            FuelWidget {
                id: fuelDisel
                anchors.horizontalCenter: parent.horizontalCenter
                stateFlag: main.width < 450
                valueLeft: valueDiselLeft
                valueRight: valueDiselRight
                leftStr: "Левый"
                rightStr: "Правый"
                titleStr: "Топливо ДГ"
            }

            DialWidget {
                id: engine
                anchors.horizontalCenter: parent.horizontalCenter
                stateFlag: main.width < 450
                valueLeft: valueEngineLeft
                valueRight: valueEngineRight
                titleStr: "Обороты двигателя"
            }
            DialWidget {
                id: disel
                anchors.horizontalCenter: parent.horizontalCenter
                stateFlag: main.width < 450
                valueLeft: valueShaftLeft
                valueRight: valueShaftRight
                titleStr: "Обороты гребного вала"
            }

        }
    }

    ScrollBar {
        id: verticalScrollBar
        width: 12; height: flickable1.height-12
        anchors.right: flickable1.right
        anchors.top: flickable1.top
        opacity: 0
        orientation: Qt.Vertical
        position: flickable1.visibleArea.yPosition
        pageSize: flickable1.visibleArea.heightRatio
        states: [
            State {
              name: "ShowBars"
              when: flickable1.movingVertically
              PropertyChanges { target: verticalScrollBar; opacity: 0.5 }
            }
        ]
        transitions: [
          Transition {
             NumberAnimation { properties: "opacity"; duration: 500 }
          }
        ]
   }
   states: [
       State {
           name: "State1"
           PropertyChanges {
               target: main
               sca:Math.max(main.width/450,0.1)
           }
           when: main.width < 450
       }
   ]

   transitions: Transition {
                from: ""; to: "State1"; reversible: true
                ParallelAnimation {
                    NumberAnimation { properties: "sca"; duration: 300}
                }
            }
}
